# -*- coding: utf-8 -*-

"""Via.me service"""
#
# Author: Wil Alvarez (aka Satanas)

import json
import traceback

from libturpial.api.interfaces.service import ServiceResponse
from libturpial.api.services.uploadpic.base import UploadService

VIAME_KEY = '3ycgz7gzer80068s80t4xl1cs'


class ViameUploader(UploadService):
    def __init__(self):
        UploadService.__init__(self, "api.via.me", "/v1/post",
            "https://api.twitter.com/1/account/verify_credentials.json")

    def do_service(self, account, filepath, message):
        try:
            _image = self._open_file(filepath)
        except:
            return self._error_opening_file(filepath)

        files = (
            ('media', self._get_pic_name(filepath), _image),
        )

        fields = (
            ('access_token', VIAME_KEY),
            ('text', message),
            ('media_type', 'photo'),
        )

        try:
            rtn = self._upload_pic(account, fields, files)
            resp = json.loads(rtn)
            if resp.has_key('error'):
                raise Exception, 'Error uploading image to via.me %s' % resp['error']['message']
            print resp
            link = "http://via.me/%s" % resp['response']['post']['id']
            return ServiceResponse(link)
        except Exception, error:
            self.log.debug("Error: %s\n%s" % (error, traceback.print_exc()))
            return ServiceResponse(err=True,
                                   err_msg='Problem uploading pic')
